#include "orb_device.h"
#include "orb_translator.h"
#include "hid_keys.h"
#include "chart_4.h"

Logical_orb orb_buffer( SpaceOrb360 );
Orb_translator translator;
byte b;
boolean has_initialized_orb=false;

PROGMEM Axis_mouse_binding axis_mouse_bindings[] =
  {
    { 5, MOUSE_AXIS_X, 3 },
    { 3, MOUSE_AXIS_Y, 3 }
  };

PROGMEM Button_mouse_binding button_mouse_bindings[] =
  {
    { 0x01, 0x01 },
    { 0x01 << 1, 0x01 << 1 },
    { 0x01 << 2, 0x01 << 2 }
  };

PROGMEM Axis_key_binding axis_key_bindings[] =
  {
    { 0, 0, 255, 0, KEY_A },
    { 0, 768, 1023, 0, KEY_D},
    { 1, 0, 255, 0, KEY_W},
    { 1, 768, 1023, 0, KEY_S},
    { 2, 0, 255, 0, KEY_N},
    { 2, 768, 1023, 0, KEY_U }
  };

const PROGMEM short Polarity[] = { 1,1,1,-1,1,1};

void setup()
{
  Serial.begin( 9600 );

  translator.set_axis_map( Axis_map_spaceorb_face );
  translator.set_polarity( Polarity );

  translator.set_axis_mouse_bindings( axis_mouse_bindings, 2 );
  translator.set_button_mouse_bindings( button_mouse_bindings, 3 );
  translator.set_axis_key_bindings( axis_key_bindings, 10 );
}

void loop()
{
  orb_device.refresh();
  if  ( Serial.available() )
  {
    b = Serial.read();
    orb_buffer.add_byte( b );
    if ( orb_buffer.has_changed() )
    {
      translator.update(orb_buffer, orb_device);
    }
  }
}
